<template>
  <div :class="className" :style="{ height: height, width: width }" />
</template>

<script>
import echarts from 'echarts';
require('echarts/theme/macarons'); // echarts theme
import resize from './mixins/resize';

export default {
  mixins: [resize],
  props: {
    className: {
      type: String,
      default: 'chart'
    },
    width: {
      type: String,
      default: '100%'
    },
    height: {
      type: String,
      default: '400px'
    },
    autoResize: {
      type: Boolean,
      default: true
    },
    chartData: {
      type: Array,
      required: false
    },

  },
  data() {
    return {
      chart: null
    };
  },
  watch: {
    chartData: {
      deep: true,
      handler(val) {
        this.setOptions(val);
      }
    }
  },
  mounted() {
    this.$nextTick(() => {
      this.initChart();
    });
  },
  beforeDestroy() {
    if (!this.chart) {
      return;
    }
    this.chart.dispose();
    this.chart = null;
  },
  methods: {
    initChart() {
      this.chart = echarts.init(this.$el, 'macarons');
      this.setOptions(this.chartData);
    },
    setOptions(chartData) {
      if (chartData) {
        const xAxisData = chartData.map(item => item.day);
        const loanCount = chartData.map(item => item.loanCount);
        const returnCount = chartData.map(item => item.returnCount);
        this.chart.setOption({
          xAxis: {
            data: xAxisData || [],
            boundaryGap: false,
            axisTick: {
              show: false
            },
            axisLabel:{
              interval:0,
              rotate:-30   //值>0向右倾斜，值<0则向左倾斜
            }
          },
          grid: {
            left: 10,
            right: 35,
            bottom: 20,
            top: 30,
            containLabel: true
          },
          tooltip: {
            trigger: 'axis',
            axisPointer: {
              type: 'cross'
            },
            padding: [5, 10]
          },
          yAxis: {
            axisTick: {
              show: false
            }
          },
          legend: {
            data: ['领取', '归还']
          },
          series: [
            {
              name: '领取',
              itemStyle: {
                normal: {
                  color: '#FF005A',
                  lineStyle: {
                    color: '#FF005A',
                    width: 2
                  }
                }
              },
              smooth: true,
              type: 'bar',

              data: loanCount || [],
              animationDuration: 2800,
              animationEasing: 'cubicInOut'
            },
            {
              name: '归还',
              smooth: true,
              type: 'bar',

              itemStyle: {
                normal: {
                  color: '#3888fa',
                  lineStyle: {
                    color: '#3888fa',
                    width: 2
                  },
                  areaStyle: {
                    color: '#f3f8ff'
                  }
                }
              },
              data: returnCount || [],
              animationDuration: 2800,
              animationEasing: 'quadraticOut'
            }
          ]
        });
      }


    }
  }
};
</script>
